
public class Ordine {

	public static final double COSTO_CONFEZIONE = 5.50;

	private int numConfezioni;
	private int sconto;
	
	// esempio di costruttore di default che richiama un 
	// costruttore
	public Ordine(){
		this(0);
	}
	
	public Ordine(int numC){
		numConfezioni = numC;
		sconto = calcolaSconto(numC);
	}
	
	// per completezza si riporta anche il costruttore completo, 
	// sebbene non venga usato
	public Ordine(int numC, int s) {
		numConfezioni = numC;
		sconto = s;
	}
	
	// metodo privato ad uso del costruttore e del metodo setNumConfezioni
	private int calcolaSconto(int numC){
		int sconto;
		if (numC >= 300)
			sconto = 30;
		else if (numC >= 200)
			sconto = 25;
		else if (numC >= 150)
			sconto = 20;
		else if (numC >= 100)
			sconto = 15;
		else if (numC >= 50)
			sconto = 10;
		else if (numC >= 25)
			sconto = 5;
		else
			sconto = 0;
		return sconto;
	}

	public int getNumConfezioni() {
		return numConfezioni;
	}

	/* 
	 * setNumConfezioni si occupa anche dell'aggiornamento 
	 * dello sconto (se cambia il numero di confezioni,
	 * cambia anche lo sconto)
	 */
	public void setNumConfezioni(int nC) {
		numConfezioni = nC;
		sconto = calcolaSconto(nC);
	}

	public int getSconto() {
		return sconto;
	}

	/*
	 * Lo sconto pu cambiare, senza che cambi il numero di confezioni
	 */
	public void setSconto(int s) {
		sconto = s;
	}

	public double importoTotale() {
		return COSTO_CONFEZIONE * numConfezioni;
	}
	
	public double importoSconto(){
		return importoTotale() * sconto / 100;
	}

	public double importoScontato() {
		return importoTotale() * (100 - sconto) / 100;
		// in alternativa:
		// return importoTotale() - importoSconto();
	}

}
